(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common'), require('ngx-toastr/index'), require('md2/index'), require('angular2-text-mask'), require('ng2-currency-mask/index'), require('@angular/http'), require('rxjs/Rx'), require('hyper-jobs-services')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@angular/common', 'ngx-toastr/index', 'md2/index', 'angular2-text-mask', 'ng2-currency-mask/index', '@angular/http', 'rxjs/Rx', 'hyper-jobs-services'], factory) :
	(factory((global['hyper-jobs-insert-credit-component'] = {}),global._angular_core,global._angular_forms,global._angular_common,global.ngxToastr_index,global.md2_index,global.angular2TextMask,global.ng2CurrencyMask_index,global._angular_http,global.rxjs_Rx,global.hyperJobsServices));
}(this, (function (exports,_angular_core,_angular_forms,_angular_common,ngxToastr_index,md2_index,angular2TextMask,ng2CurrencyMask_index,_angular_http,rxjs_Rx,hyperJobsServices) { 'use strict';

var AddCreditService = (function () {
    /**
     * @param {?} Http
     * @param {?} environments
     * @param {?} _hyperCookieService
     */
    function AddCreditService(Http$$1, environments, _hyperCookieService) {
        var _this = this;
        this.Http = Http$$1;
        this.environments = environments;
        this._hyperCookieService = _hyperCookieService;
        this.killAll = true;
        hyperJobsServices.BroadcastEventService.event('takeWhile').subscribe(function (code) {
            _this.killAll = code === '0';
        });
    }
    /**
     * @return {?}
     */
    AddCreditService.prototype.ngOnInit = function () {
    };
    /**
     * @return {?}
     */
    AddCreditService.prototype.getEnvironments = function () {
        return this.environments;
    };
    /**
     * @param {?} dado
     * @return {?}
     */
    AddCreditService.prototype.sendPayment = function (dado) {
        var _this = this;
        var /** @type {?} */ headers = new _angular_http.Headers({
            'Authorization': 'Bearer ' + this._hyperCookieService.getCookie().JWT,
            'accept-language': 'pt_BR',
            'Content-Type': 'application/json'
        });
        var /** @type {?} */ options = new _angular_http.RequestOptions({ headers: headers }); // Create a request option    
        return this.Http.post(this.environments.apiUrl + 'user/insertCredit', JSON.stringify(dado), options)
            .map(function (res) { return res.json(); })
            .takeWhile(function () { return _this.killAll; })
            .catch(function (err) { return rxjs_Rx.Observable.throw(err.json().error || 'Server error'); });
    };
    return AddCreditService;
}());
AddCreditService.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
AddCreditService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: ['environments',] },] },
    { type: hyperJobsServices.HyperCookieService, },
]; };

var AddCreditComponent = (function () {
    /**
     * @param {?} _AddCreditService
     * @param {?} _toastrService
     * @param {?} _hyperCookieService
     */
    function AddCreditComponent(_AddCreditService, _toastrService, _hyperCookieService) {
        this._AddCreditService = _AddCreditService;
        this._toastrService = _toastrService;
        this._hyperCookieService = _hyperCookieService;
        this.payment_method = 'credit-card';
        this.urlAssets = '';
        this.refLogin = new rxjs_Rx.Subscription;
        this.cardMask = [/\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
        this.MoneyMask = {
            prefix: 'R$ ',
            thousands: '.',
            decimal: ',',
            align: 'left'
        };
    }
    /**
     * @return {?}
     */
    AddCreditComponent.prototype.ngOnInit = function () {
        this.urlAssets = this._AddCreditService.getEnvironments().assets;
    };
    /**
     * @param {?} form
     * @return {?}
     */
    AddCreditComponent.prototype.sendPay = function (form) {
        var /** @type {?} */ _self = this;
        this.cookieVal = this._hyperCookieService.getCookie();
        if (this.cookieVal === undefined || this.cookieVal === null || this.cookieVal === {}) {
            hyperJobsServices.BroadcastEventService.event('openLoginModal').emit(true);
            this.refLogin = hyperJobsServices.BroadcastEventService.event('listenerLoginComponent').subscribe(function (data) {
                _self.serviceInsert(form);
                _self.refLogin.unsubscribe();
            });
        }
        else {
            _self.serviceInsert(form);
        }
    };
    /**
     * @param {?} form
     * @return {?}
     */
    AddCreditComponent.prototype.serviceInsert = function (form) {
        var _this = this;
        var /** @type {?} */ aux = this.payment_method;
        this._AddCreditService.sendPayment(form.value).subscribe(function (response) {
            if (response.data.billeturl !== undefined) {
                window.open(response.data.billeturl, '_blank');
            }
            if (response.return == false) {
                _this._toastrService.warning(response.msg, 'Atenção');
            }
            else {
                _this._toastrService.success(response.msg, 'Sucesso');
                form.reset();
                _this.payment_method = aux;
            }
        });
    };
    /**
     * @return {?}
     */
    AddCreditComponent.prototype.ngOnDestroy = function () {
        this.refLogin.unsubscribe();
    };
    return AddCreditComponent;
}());
AddCreditComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'app-add-credit',
                template: "<div class=\"addcredit\"> <div class=\"\"> <div class=\"title\"> <h1>Inserir Crédito</h1> </div> <div class=\"subtitle\"> <span class=\"center\">Para inciar sua consulta é necessário que você tenha créditos disponíveis.</span><br> <span class=\"center\">Escolha o valor que você deseja e a forma de pagamento. É simples, rápido e totalmente seguro.</span> </div> <form role=\"form\" #f=\"ngForm\" (ngSubmit)=\"sendPay(f)\"> <div class=\"\"> <div class=\"type center\"> <div class=\"contentOptions\"> <label><input type=\"radio\" [checked]=\"\" [(ngModel)]=\"payment_method\" name=\"payment_method\" value=\"credit-card\"> <i class=\"fa fa-credit-card\"></i> Cartão de Crédito </label> <label><input type=\"radio\" [(ngModel)]=\"payment_method\"  name=\"payment_method\" value=\"billet\"> <i class=\"fa fa-barcode\"></i> Boleto Bancário </label> </div> </div> </div> <div class=\"\"> <div class=\"\"> <label for=\"nameCoin\">Escolha a moeda</label> <select class=\"inputPattern fieldsInput\" placeholder=\"Moeda\" id=\"coin\" [(ngModel)]=\"coin\" name=\"coin\"> <option value=\"BRL\">R$ - Real</option> </select> </div> <div class=\"\"> <label for=\"amount\">Valor do Crédito</label> <input id=\"amount\" #name=\"ngModel\" class=\"inputPattern fieldsInput\" [class.form-control-danger]=\"name.errors && name.touched || (requiredError && !name.touched)\" [(ngModel)]=\"amount\" name=\"amount\" required placeholder=\"Valor do crédito\" currencyMask [options]=\"MoneyMask\"> <div *ngIf=\"(name.errors && (name.dirty || name.touched)) || (requiredError && !name.touched)\"> <small class=\"form-feedback\" [hidden]=\"!name.errors?.required\">Campo obrigatório. </small> </div> </div> </div> <div class=\"\" *ngIf=\"payment_method === 'credit-card'\"> <div class=\"cardAccept\"> <div class=\"\"> <img [src]=\"urlAssets + 'img/credit-card/mastercard.png'\"> <img [src]=\"urlAssets + 'img/credit-card/visa.png'\"> <img [src]=\"urlAssets + 'img/credit-card/diners.png'\"> <img [src]=\"urlAssets + 'img/credit-card/amex.png'\"> <img [src]=\"urlAssets + 'img/credit-card/elo.png'\"> </div> </div> <div class=\"\"> <div> <label>Número do Cartão</label> <input id=\"card\" class=\"inputPattern\" [textMask]=\"{mask: cardMask}\" autocomplete=\"false\" #numberCard=\"ngModel\" name=\"numberCard\" ngModel required creditCard placeholder=\"Nº do Cartão de Crédito (Somente Numeros)\" [class.form-control-danger]=\"(!numberCard.valid && numberCard.touched)  || (requiredError && !numberCard.dirty)\"> <label for=\"card\">Nº do Cartão de Crédito (Somente Numeros)</label> <div *ngIf=\"numberCard.errors && (numberCard.dirty || numberCard.touched)\"> <small class=\"form-feedback\" *ngIf=\"numberCard.errors?.creditCard\">Cartão inválido</small> <small class=\"form-feedback\" *ngIf=\"numberCard.errors?.required\">Campo obrigatório</small> </div> </div> <div> <label>Nome do Títular</label> <input type=\"text\" [(ngModel)]=\"nameCard\" name=\"nameCard\" class=\"inputPattern fieldsInput\" placeholder=\"Exatamente como impresso no cartão\"> </div> <div class=\"dateValidate fieldsInput\"> <label>Data de Validade</label> </div> <div class=\"\"> <md2-select name=\"months\" [(ngModel)]=\"months\" class=\"inputPattern\" placeholder=\"Mês\"> <md2-option value=\"01\">Janeiro</md2-option> <md2-option value=\"02\">Fevereiro</md2-option> <md2-option value=\"03\">Março</md2-option> <md2-option value=\"04\">Abril</md2-option> <md2-option value=\"05\">Maio</md2-option> <md2-option value=\"06\">Junho</md2-option> <md2-option value=\"07\">Julho</md2-option> <md2-option value=\"08\">Agosto</md2-option> <md2-option value=\"09\">Setembro</md2-option> <md2-option value=\"10\">Outubro</md2-option> <md2-option value=\"11\">Novembro</md2-option> <md2-option value=\"12\">Dezembro</md2-option> </md2-select> </div> <div class=\"\"> <md2-select [(ngModel)]=\"year\" name=\"year\" class=\"inputPattern\" placeholder=\"Ano\"> <md2-option value=\"2017\">2017</md2-option> <md2-option value=\"2018\">2018</md2-option> <md2-option value=\"2019\">2019</md2-option> <md2-option value=\"2020\">2020</md2-option> <md2-option value=\"2021\">2021</md2-option> <md2-option value=\"2022\">2022</md2-option> <md2-option value=\"2023\">2023</md2-option> <md2-option value=\"2024\">2024</md2-option> <md2-option value=\"2025\">2025</md2-option> <md2-option value=\"2026\">2026</md2-option> <md2-option value=\"2027\">2027</md2-option> </md2-select> </div> <div class=\"\"> <input type=\"text\" [(ngModel)]=\"numberCVV\" name=\"numberCVV\" id=\"numberCVV\" class=\"inputPattern\" maxlength=\"4\" placeholder=\"CVV\"> <label for=\"numberCVV\">CVV</label> </div> </div> </div> <div class=\"\" *ngIf=\"payment_method === 'billet'\"> <p>Pagamento à vista com Boleto Bancário.</p> <p>1 - <strong>IMPORTANTE</strong> - verifique a data de vencimento do boleto. Em caso de não pagamento do boleto até a data de vencimento, o pedido será cancelado.</p> <p>2 - O acesso integral aos recursos da plataforma estará disponível somente após a confirmação do pagamento pelo banco, o que pode levar até <strong>5 dias úteis</strong>.</p> <p>3 - O pagamento pode ser realizado pela internet, utilizando o código de barras, ou diretamente em bancos, lotéricas e correios, apresentado o boleto impresso.</p> </div> <div class=\"\"> <div class=\"\"> <button type=\"submit\" class=\"btn btn-primary\">Enviar</button> </div> </div> </form> </div>",
                styles: [".center { text-align: center; } .addcredit { margin: 0% 25%; padding: 10px; } .addcredit .title { text-align: center; color: #0694d8; padding: 10px; font-size: 16px; } .addcredit .subtitle { padding: 10px; } .addcredit .fieldsInput { margin-top: 3px; } .addcredit .cardAccept img { max-width: 36px; margin-right: 5px; filter: grayscale(100%); } .addcredit .cardAccept img.selected { filter: grayscale(0%); } .addcredit .btn { margin: 10px 0px; } "]
            },] },
];
/**
 * @nocollapse
 */
AddCreditComponent.ctorParameters = function () { return [
    { type: AddCreditService, },
    { type: ngxToastr_index.ToastrService, },
    { type: hyperJobsServices.HyperCookieService, },
]; };

var InsertCreditModule = (function () {
    function InsertCreditModule() {
    }
    /**
     * @param {?} environments
     * @return {?}
     */
    InsertCreditModule.forRoot = function (environments) {
        return {
            ngModule: InsertCreditModule,
            providers: [
                { provide: 'environments', useValue: environments },
                AddCreditService
            ]
        };
    };
    return InsertCreditModule;
}());
InsertCreditModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [
                    _angular_common.CommonModule,
                    _angular_forms.FormsModule,
                    ngxToastr_index.ToastrModule.forRoot({
                        timeOut: 5000,
                        enableHtml: true,
                        progressBar: true,
                        positionClass: 'toast-top-right',
                        closeButton: true,
                        preventDuplicates: true
                    }),
                    md2_index.Md2Module,
                    angular2TextMask.TextMaskModule,
                    ng2CurrencyMask_index.CurrencyMaskModule
                ],
                declarations: [
                    AddCreditComponent
                ],
                exports: [
                    AddCreditComponent
                ]
            },] },
];
/**
 * @nocollapse
 */
InsertCreditModule.ctorParameters = function () { return []; };

exports.InsertCreditModule = InsertCreditModule;
exports.AddCreditComponent = AddCreditComponent;
exports.AddCreditService = AddCreditService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
